
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_team_assignmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_team_assignments = await db.game_team_assignments.create(
            {
                id: data.id || undefined,
        
        seed_score_snapshot: data.seed_score_snapshot
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await game_team_assignments.setGame_team( data.game_team || null, {
            transaction,
        });
        
        await game_team_assignments.setPlayer( data.player || null, {
            transaction,
        });
        
        await game_team_assignments.setGuest( data.guest || null, {
            transaction,
        });
        
        await game_team_assignments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return game_team_assignments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_team_assignmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                seed_score_snapshot: item.seed_score_snapshot
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_team_assignments = await db.game_team_assignments.bulkCreate(game_team_assignmentsData, { transaction });

        // For each item created, replace relation files
        

        return game_team_assignments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const game_team_assignments = await db.game_team_assignments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.seed_score_snapshot !== undefined) updatePayload.seed_score_snapshot = data.seed_score_snapshot;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_team_assignments.update(updatePayload, {transaction});

        
        
        if (data.game_team !== undefined) {
            await game_team_assignments.setGame_team(
              
              data.game_team,
              
              { transaction }
            );
        }
        
        if (data.player !== undefined) {
            await game_team_assignments.setPlayer(
              
              data.player,
              
              { transaction }
            );
        }
        
        if (data.guest !== undefined) {
            await game_team_assignments.setGuest(
              
              data.guest,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await game_team_assignments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return game_team_assignments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_team_assignments = await db.game_team_assignments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_team_assignments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_team_assignments) {
                await record.destroy({transaction});
            }
        });


        return game_team_assignments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_team_assignments = await db.game_team_assignments.findByPk(id, options);

        await game_team_assignments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_team_assignments.destroy({
            transaction
        });

        return game_team_assignments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_team_assignments = await db.game_team_assignments.findOne(
            { where },
            { transaction },
        );

        if (!game_team_assignments) {
            return game_team_assignments;
        }

        const output = game_team_assignments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.game_team = await game_team_assignments.getGame_team({
            transaction
        });
        
        
        output.player = await game_team_assignments.getPlayer({
            transaction
        });
        
        
        output.guest = await game_team_assignments.getGuest({
            transaction
        });
        
        
        output.organizations = await game_team_assignments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.game_teams,
        as: 'game_team',
        
        where: filter.game_team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.game_team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.game_team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.players,
        as: 'player',
        
        where: filter.player ? {
          [Op.or]: [
            { id: { [Op.in]: filter.player.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.player.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.game_guests,
        as: 'guest',
        
        where: filter.guest ? {
          [Op.or]: [
            { id: { [Op.in]: filter.guest.split('|').map(term => Utils.uuid(term)) } },
            {
              nickname: {
                [Op.or]: filter.guest.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.seed_score_snapshotRange) {
                const [start, end] = filter.seed_score_snapshotRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    seed_score_snapshot: {
                    ...where.seed_score_snapshot,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    seed_score_snapshot: {
                    ...where.seed_score_snapshot,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_team_assignments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_team_assignments',
                        'seed_score_snapshot',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_team_assignments.findAll({
            attributes: [ 'id', 'seed_score_snapshot' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['seed_score_snapshot', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.seed_score_snapshot,
        }));
    }

    
};

